<?xml version="1.0" encoding="ascii"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
          "DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
<head>
  <title>Halberd.crew</title>
  <link rel="stylesheet" href="epydoc.css" type="text/css" />
  <script type="text/javascript" src="epydoc.js"></script>
</head>

<body bgcolor="white" text="black" link="blue" vlink="#204080"
      alink="#204080">
<!-- ==================== NAVIGATION BAR ==================== -->
<table class="navbar" border="0" width="100%" cellpadding="0"
       bgcolor="#a0c0ff" cellspacing="0">
  <tr valign="middle">
  <!-- Home link -->
      <th>&nbsp;&nbsp;&nbsp;<a
        href="Halberd-module.html">Home</a>&nbsp;&nbsp;&nbsp;</th>

  <!-- Tree link -->
      <th>&nbsp;&nbsp;&nbsp;<a
        href="module-tree.html">Trees</a>&nbsp;&nbsp;&nbsp;</th>

  <!-- Index link -->
      <th>&nbsp;&nbsp;&nbsp;<a
        href="identifier-index.html">Indices</a>&nbsp;&nbsp;&nbsp;</th>

  <!-- Help link -->
      <th>&nbsp;&nbsp;&nbsp;<a
        href="help.html">Help</a>&nbsp;&nbsp;&nbsp;</th>

      <th class="navbar" width="100%"></th>
  </tr>
</table>
<table width="100%" cellpadding="0" cellspacing="0">
  <tr valign="top">
    <td width="100%">
      <span class="breadcrumbs">
        <a href="Halberd-module.html">Package&nbsp;Halberd</a> ::
        Module&nbsp;crew
      </span>
    </td>
    <td>
      <table cellpadding="0" cellspacing="0">
        <!-- hide/show private -->
        <tr><td align="right"><span class="options">[<a href="javascript:void(0);" class="privatelink"
    onclick="toggle_private();">hide&nbsp;private</a>]</span></td></tr>
        <tr><td align="right"><span class="options"
            >[<a href="frames.html" target="_top">frames</a
            >]&nbsp;|&nbsp;<a href="Halberd.crew-module.html"
            target="_top">no&nbsp;frames</a>]</span></td></tr>
      </table>
    </td>
  </tr>
</table>
<!-- ==================== MODULE DESCRIPTION ==================== -->
<h1 class="epydoc">Module crew</h1><p class="nomargin-top"><span class="codelink"><a href="Halberd.crew-pysrc.html">source&nbsp;code</a></span></p>
<h1 class="heading">Work crew pattern of parallel scanners</h1>
    <h2 class="heading">Overview</h2>
      <p>A work crew is instantiated passing a ScanTask object as a 
      parameter, thus defining the target and the way the scanning should 
      be done. After the initialization of the work crew it can be used to 
      scan the target and get the obtained clues back.</p>
<pre class="py-doctest">
<span class="py-prompt">&gt;&gt;&gt; </span>crew = WorkCrew(scantask)
<span class="py-prompt">&gt;&gt;&gt; </span>clues = crew.scan()</pre>
    <h2 class="heading">Requirements</h2>
      <p>These are the features that the WorkCrew must provide:</p>
      <ol start="1">
        <li>
          There are 3 different types of consumers:
          <ul>
            <li>
              Controller thread (Performs timing + error-checking).
            </li>
            <li>
              Local scanning thread.
            </li>
            <li>
              Remote scanning thread.
            </li>
          </ul>
        </li>
        <li>
          We need a way to signal:
          <ul>
            <li>
              When a fatal error has happened.
            </li>
            <li>
              When the user has pressed Control-C
            </li>
          </ul>
        </li>
      </ol>
    <h2 class="heading">Types of scanning threads</h2>
      <p>The WorkCrew object spawns different kinds of threads. Here's a 
      brief summary of what they do:</p>
      <ul>
        <li>
          Manager: Detects when the time for performing the scan has 
          expired and notifies the rest of the threads. This code is 
          executed in the main thread in order to be able to appropriately 
          catch signals, etc.
        </li>
        <li>
          Scanner: Performs a load-balancer scan from the current machine.
        </li>
      </ul>
      <p>The following is a diagram showing the way it works:</p>
<pre class="literalblock">
                                    .--&gt; Manager --.
                                    |              |
                                    +--&gt; Scanner --+
       .----------.   .----------.  |              |   .-------.
IN --&gt; | ScanTask |-&gt;-| WorkCrew |--+--&gt; Scanner --+-&gt;-| Clues |--&gt; OUT
       `----------'   `----------'  |              |   `-------'
                                    +--&gt; Scanner --+
                                    |              |
                                    `--&gt; Scanner --'
</pre>

<!-- ==================== CLASSES ==================== -->
<a name="section-Classes"></a>
<table class="summary" border="1" cellpadding="3"
       cellspacing="0" width="100%" bgcolor="white">
<tr bgcolor="#70b0f0" class="table-header">
  <td colspan="2" class="table-header">
    <table border="0" cellpadding="0" cellspacing="0" width="100%">
      <tr valign="top">
        <td align="left"><span class="table-header">Classes</span></td>
        <td align="right" valign="top"
         ><span class="options">[<a href="#section-Classes"
         class="privatelink" onclick="toggle_private();"
         >hide private</a>]</span></td>
      </tr>
    </table>
  </td>
</tr>
<tr class="private">
    <td width="15%" align="right" valign="top" class="summary">
      <span class="summary-type">&nbsp;</span>
    </td><td class="summary">
        <a href="Halberd.crew.ScanState-class.html" class="summary-name" onclick="show_private();">ScanState</a><br />
      Shared state among scanner threads.
    </td>
  </tr>
<tr>
    <td width="15%" align="right" valign="top" class="summary">
      <span class="summary-type">&nbsp;</span>
    </td><td class="summary">
        <a href="Halberd.crew.WorkCrew-class.html" class="summary-name">WorkCrew</a><br />
      Pool of scanners working in parallel.
    </td>
  </tr>
<tr class="private">
    <td width="15%" align="right" valign="top" class="summary">
      <span class="summary-type">&nbsp;</span>
    </td><td class="summary">
        <a href="Halberd.crew.BaseScanner-class.html" class="summary-name" onclick="show_private();">BaseScanner</a><br />
      Base class for load balancer scanning threads.
    </td>
  </tr>
<tr class="private">
    <td width="15%" align="right" valign="top" class="summary">
      <span class="summary-type">&nbsp;</span>
    </td><td class="summary">
        <a href="Halberd.crew.Scanner-class.html" class="summary-name" onclick="show_private();">Scanner</a><br />
      Scans the target host from the local machine.
    </td>
  </tr>
<tr class="private">
    <td width="15%" align="right" valign="top" class="summary">
      <span class="summary-type">&nbsp;</span>
    </td><td class="summary">
        <a href="Halberd.crew.Manager-class.html" class="summary-name" onclick="show_private();">Manager</a><br />
      Performs management tasks during the scan.
    </td>
  </tr>
</table>
<!-- ==================== VARIABLES ==================== -->
<a name="section-Variables"></a>
<table class="summary" border="1" cellpadding="3"
       cellspacing="0" width="100%" bgcolor="white">
<tr bgcolor="#70b0f0" class="table-header">
  <td colspan="2" class="table-header">
    <table border="0" cellpadding="0" cellspacing="0" width="100%">
      <tr valign="top">
        <td align="left"><span class="table-header">Variables</span></td>
        <td align="right" valign="top"
         ><span class="options">[<a href="#section-Variables"
         class="privatelink" onclick="toggle_private();"
         >hide private</a>]</span></td>
      </tr>
    </table>
  </td>
</tr>
<tr class="private">
    <td width="15%" align="right" valign="top" class="summary">
      <span class="summary-type">&nbsp;</span>
    </td><td class="summary">
        <a name="__package__"></a><span class="summary-name">__package__</span> = <code title="'Halberd'"><code class="variable-quote">'</code><code class="variable-string">Halberd</code><code class="variable-quote">'</code></code>
    </td>
  </tr>
</table>
<!-- ==================== NAVIGATION BAR ==================== -->
<table class="navbar" border="0" width="100%" cellpadding="0"
       bgcolor="#a0c0ff" cellspacing="0">
  <tr valign="middle">
  <!-- Home link -->
      <th>&nbsp;&nbsp;&nbsp;<a
        href="Halberd-module.html">Home</a>&nbsp;&nbsp;&nbsp;</th>

  <!-- Tree link -->
      <th>&nbsp;&nbsp;&nbsp;<a
        href="module-tree.html">Trees</a>&nbsp;&nbsp;&nbsp;</th>

  <!-- Index link -->
      <th>&nbsp;&nbsp;&nbsp;<a
        href="identifier-index.html">Indices</a>&nbsp;&nbsp;&nbsp;</th>

  <!-- Help link -->
      <th>&nbsp;&nbsp;&nbsp;<a
        href="help.html">Help</a>&nbsp;&nbsp;&nbsp;</th>

      <th class="navbar" width="100%"></th>
  </tr>
</table>
<table border="0" cellpadding="0" cellspacing="0" width="100%%">
  <tr>
    <td align="left" class="footer">
    Generated by Epydoc 3.0.1 on Sat Aug 14 15:09:27 2010
    </td>
    <td align="right" class="footer">
      <a target="mainFrame" href="http://epydoc.sourceforge.net"
        >http://epydoc.sourceforge.net</a>
    </td>
  </tr>
</table>

<script type="text/javascript">
  <!--
  // Private objects are initially displayed (because if
  // javascript is turned off then we want them to be
  // visible); but by default, we want to hide them.  So hide
  // them unless we have a cookie that says to show them.
  checkCookie();
  // -->
</script>
</body>
</html>
